/*-----------------------------------------------------------------------

File  : cco_forward_contraction.h

Author: Stephan Schulz

Contents
 
  Functions that apply the processed clause sets to simplify or
  eleminate a potential new clause. Extracted from
  cco_proofproc.[ch]. 

Changes

<1> Mon Nov  9 17:46:50 MET 1998
    New

-----------------------------------------------------------------------*/

#ifndef CCO_FORWARD_CONTRACTION

#define CCO_FORWARD_CONTRACTION

#include <cio_output.h>
#include <cco_simplification.h>
#include <cco_factoring.h>
#include <cco_eqnresolving.h>
#include <cco_paramodulation.h>
#include <ccl_subsumption.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/




/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/


bool ForwardContractClause(ProofState_p state, ProofControl_p control,
			   Clause_p clause); 

Clause_p ForwardContractSet(ProofState_p state, ProofControl_p
			    control, ClauseSet_p set, long*
			    count_eleminated);

void     ClauseSetReweight(HCB_p heuristic, ClauseSet_p set);

Clause_p ForwardContractSetReweight(ProofState_p state, ProofControl_p
				    control, ClauseSet_p set, long*
				    count_eleminated);

void     ClauseSetFilterReweigth(ProofState_p state, ProofControl_p
				 control, ClauseSet_p set, long*
				 count_eleminated);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





