/*-----------------------------------------------------------------------

File  : che_heu_fifo.c

Author: Stephan Schulz

Contents
 
  Functions describing the FIFO heuristic (may be used to hack
  rewriting...)

Changes

<1> Tue Jun  9 01:51:42 MET DST 1998
    New

-----------------------------------------------------------------------*/

#include "che_heu_fifo.h"



/*---------------------------------------------------------------------*/
/*                        Global Variables                             */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                      Forward Declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                         Internal Functions                          */
/*---------------------------------------------------------------------*/



/*---------------------------------------------------------------------*/
/*                         Exported Functions                          */
/*---------------------------------------------------------------------*/


/*-----------------------------------------------------------------------
//
// Function: HCBFIFOtCreate()
//
//   Create a HCB entry for the FIFO heuristic.
//
// Global Variables: -
//
// Side Effects    : Memory operations
//
/----------------------------------------------------------------------*/

HCB_p HCBFIFOCreate(WFCBPARAMETERS)
{
   WFCB_p        wfcb;
   HCB_p         hcb     = HCBAlloc();
   long          index;

   wfcb = FIFOEvalInit(NULL, NULL, NULL, NULL, NULL, NULL);
   index = PDArrayStoreP(hcb->wfcb_list, wfcb);     /* This is really */
   PDArrayAssignInt(hcb->select_switch, index, 1);  /* redundant */

   hcb->hcb_select = HCBSingleWeightClauseSelect;

   return hcb;
}


/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/


