/*-----------------------------------------------------------------------

File  : che_to_precgen.h

Author: Stephan Schulz

Contents
 
  Routines for generating precedences for term orderings

Changes

<1> Fri Oct 16 17:01:23 MET DST 1998
    New

-----------------------------------------------------------------------*/

#ifndef CHE_TO_PRECGEN

#define CHE_TO_PRECGEN

#include <clb_simple_stuff.h>
#include <che_clausesetfeatures.h>
#include <che_lpogen.h>
#include <stdlib.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

typedef enum
{
   PNoMethod = 0,       /* Nothing */
   PWeightAxioms,       /* Joachims hack */
   PUnaryFirst,         /* My hack ;-) */
   PArity,              /* Sort by arity */
   PInvArity,           /* Sort by inverse arity */
   PConstMax,           /* Sort by arity, but constants first (Default
			   for SPASS) */
   PByFrequency,        /* Make often occuring symbols big */
   PByInvFrequency      /* Make often occuring symbols small */
}TOPrecGenMethod;


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/


extern char* TOPrecGenNames[];

#define TOGetPrecGenName(method) \
        (assert((method)>=PNoMethod), assert((method)<=PConstFirst), \
	 TOWeightGenNames[(method)])

TOPrecGenMethod TOTranslatePrecGenMethod(char* name);

void TOGeneratePrecedence(OCB_p ocb, ClauseSet_p axioms,
			  TOPrecGenMethod method); 



#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/






